import Vue from 'vue'
import Vuex from 'vuex'

Vue.use(Vuex)

const store = new Vuex.Store({
  state: {
    loadding: false,
    pageSize: 10,
  }
})
export const modules = {
  login: () => require('./login').default,
  main: () => require('./main').default,
  menuConfig: () => require('./menuConfig').default,
  material: () => require('./material').default,
  management: () => require('./management').default,
  user: () => require('./user').default,
  reply: () => require('./reply').default,
}

Object.keys(modules).forEach((modKey) => {
  const modNS = modKey.split('/')
  const getMod = modules[modKey]
  store.registerModule(...modNS, getMod())
})

export default store
