import ajax from '../util/ajax'
import api from '../util/api'

export default {
  namespaced: true,
  state: {
    remember: null,
    userName: '',
    passWord: ''
  },
  mutations: {
    updateRemember (state, data) {
      state.remember = data
    },
    updateUserName (state, data) {
      state.userName = data
    },
    updatePassWord (state, data) {
      state.passWord = data
    }
  },
  actions: {
    login (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.common.login,
          data: {
            ...data,
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    setRemember ({ commit }, data) {
      localStorage.setItem('remember', data)
      if (data === 'true') {
        data = true
      } else if (data === 'false') {
        data = false
      }
      commit('updateRemember', data)
    },
    setUserName ({ commit }, data) {
      localStorage.setItem('userName', data)
      commit('updateUserName', data)
    },
    setPassWord ({ commit }, data) {
      localStorage.setItem('passWord', data)
      commit('updatePassWord', data)
    },
  }
}
