import ajax from '../util/ajax'
import api from '../util/api'

export default {
  namespaced: true,
  state: {
    img: [],
    view: []
  },
  mutations: {
    updateImg (state, data) {
      state.img = data.list || []
    },
    updateView (state, data) {
      state.view = data || []
    }
  },
  actions: {
    getImg (context, data) {
      return new Promise((resolve, reject) => {
        ajax({
          ...api.material.getImg,
          urlData: {
            ...data,
          },
          queryData: {
            page: 1,
            pagesize: 10000
          }
        }).then(res => {
          res.list = res.list || []
          res.list.forEach((curr) => {
            curr.checked = false
            curr.media_id = curr.MediaId
            curr.url = curr.Url
          })
          context.commit('updateImg', res)
          resolve(res)
        }).catch(reject)
      })
    },
    getView (context, data) {
      // return new Promise((resolve, reject) => {
      //   ajax({
      //     ...api.common.login,
      //     data: {
      //       ...data,
      //     }
      //   }).then(res => {
      //     context.commit('updateList', res)
      //     resolve(res)
      //   }).catch(reject)
      // })
      data = [
        {
          "type": "media_id",
          "name": "图片",
          "media_id": "MEDIA_ID1",
          text: "1",
          url: 'http://mmbiz.qpic.cn/mmbiz_jpg/PiajxSqBRaEIQxibpLbyuSK4TssiajqknJS6dACV5IoTxppdoyfGEYScCFMqV3dgFzf2tGqy2IiciaysTlaZt6zchibA/0?wx_fmt=jpeg'
        },
        {
          "type": "media_id",
          "name": "图片",
          "media_id": "MEDIA_ID1",
          text: "2",
          url: 'http://mmbiz.qpic.cn/mmbiz_jpg/PiajxSqBRaEIQxibpLbyuSK4TssiajqknJS6dACV5IoTxppdoyfGEYScCFMqV3dgFzf2tGqy2IiciaysTlaZt6zchibA/0?wx_fmt=jpeg'
        },
        {
          "type": "media_id",
          "name": "图片",
          "media_id": "MEDIA_ID1",
          text: "3dhkshfhdskjfhjkshdfhdshkjfhshdfihsifjsdnvkhsihfioshifhisohfshi",
          url: 'http://mmbiz.qpic.cn/mmbiz_jpg/PiajxSqBRaEIQxibpLbyuSK4TssiajqknJS6dACV5IoTxppdoyfGEYScCFMqV3dgFzf2tGqy2IiciaysTlaZt6zchibA/0?wx_fmt=jpeg'
        },
      ]
      data.forEach((curr) => {
        curr.checked = false
      })
      context.commit('updateView', data)
    },
    deleteImg (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.material.deleteImg,
          urlData: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    addImg (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.material.addImg,
          data: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    reflshImg (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.material.reflshImg,
          urlData: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    }
  }
}
