import ajax from '../util/ajax'
import api from '../util/api'
import Vue from 'vue'
// import { Message } from 'iview'

const loop = (data, setTrue) => {
  let returnData = {}
  data.mainPlusActive = false
  if (setTrue) {
    if (setTrue.type === 1) {
      data.mainPlusActive = true
    }
  }
  data.button.forEach((currentValue, index) => {
    currentValue.active = false
    currentValue.subPlusActive = false
    if (currentValue.sub_button) {
      currentValue.sub_button.forEach((curr, ind) => {
        curr.active = false
        if (setTrue) {
          if (setTrue.type === 2) {
            if (index === setTrue.parentIndex && ind === setTrue.index) {
              curr.active = true
            }
          }
        }
      })
    }
    if (setTrue) {
      if (setTrue.type === 0) {
        if (index === setTrue.index) {
          currentValue.active = true
        }
      } else if (setTrue.type === 3) {
        if (index === setTrue.index) {
          currentValue.subPlusActive = true
        }
      }
    }
  })
  returnData.mainPlusActive = data.mainPlusActive
  returnData.button = []
  data.button.forEach((currentValue) => {
    if (currentValue.sub_button) {
      currentValue.sub_button.forEach((curr, ind) => {
        currentValue.sub_button.splice(ind, 1, curr)
      })
    }
    returnData.button.push(currentValue)
  })
  return JSON.parse(JSON.stringify(returnData))
}

export default {
  namespaced: true,
  state: {
    menuJson: {
      'button': [],
      mainPlusActive: false
    },
    changed: false
  },
  mutations: {
    updateMenu (state, data) {
      state.menuJson.button = data.button || []
    },
    updateAddMain (state, data) {
      state.menuJson.button.push(data)
      Vue.set(state.menuJson.button, state.menuJson.button.length - 1, data)
    },
    updateSetMain (state, data) {
      if (data.item) { // data有值时，为修改
        Vue.set(state.menuJson.button, data.index, data.item)
        // state.menuJson.button.splice(data.index, 1, data.item)
      } else { // data为空时，为删除
        state.menuJson.button.splice(data.index, 1)
      }
    },
    updateAddSub (state, data) {
      if (!state.menuJson.button[data.index].sub_button) {
        Vue.set(state.menuJson.button, data.index, {
          ...state.menuJson.button[data.index],
          sub_button: []
        })
      }
      console.log(state.menuJson.button)
      state.menuJson.button[data.index].sub_button.push(data.item)
      loop(state.menuJson)
    },
    updateSetSub (state, data) {
      if (data.item) { // data有值时，为修改
        Vue.set(state.menuJson.button[data.parentIndex].sub_button, data.index, data.item)
      } else { // data为空时，为删除
        state.menuJson.button[data.parentIndex].sub_button.splice(data.index, 1)
      }
    },
    updateMainActive (state, data) {
      data.type = 0
      state.menuJson = loop(state.menuJson, data)
    },
    updateSubActive (state, data) {
      data.type = 2
      state.menuJson = loop(state.menuJson, data)
    },
    updateMainPlusActive (state) {
      state.menuJson = loop(state.menuJson, { type: 1 })
    },
    updateSubPlusActive (state, data) {
      data.type = 3
      state.menuJson = loop(state.menuJson, data)
    },
    clearMenu (state) {
      state.menuJson = loop(state.menuJson)
    },
    updateChanged (state, data) {
      state.changed = data
    },
  },
  actions: {
    getWechatMenu (context) {
      return new Promise((resolve, reject) => {
        ajax({
          ...api.wechatMenu.getWechatMenu
        }).then((res) => {
          let button = []
          if (res) {
            button = res.menu.menu.button
            res.imgList = res.imgList || []
            res.imgList.forEach((c, i) => {
              if (!c) {
                res.imgList.splice(i, 1)
              }
            })
            button.forEach((current) => {
              if (current.type === 'click') {
                current.type = 'text'
                current.value = ((res.keyList.filter(item => (item || { KeyId: '' }).KeyId === current.key) || [])[0] || { Value: '' }).Value
              } else if (current.type === 'media_id') {
                let filter = res.imgList.filter(item => item.MediaId === current.media_id)
                if (filter.length > 0) {
                  current.url = filter[0].Url ? filter[0].Url : ''
                }
              }
              if (current.sub_button) {
                current.sub_button.forEach((curr) => {
                  if (curr.type === 'click') {
                    curr.type = 'text'
                    curr.value = ((res.keyList.filter(item => (item || { KeyId: '' }).KeyId === curr.key) || [])[0] || { Value: '' }).Value
                  } else if (curr.type === 'media_id') {
                    let filter = res.imgList.filter(item => item.MediaId === curr.media_id)
                    if (filter.length > 0) {
                      curr.url = filter[0].Url ? filter[0].Url : ''
                    }
                  }
                })
              }
            })
          }
          context.commit('updateMenu', loop({ button }))
          resolve()
        }).catch(reject)
      })
    },
    clear (context, data) {
      if (data.type === 0) {
        data.index = context.state.menuJson.button.length - 1
        context.commit('updateMainActive', data)
      } else if (data.type === 1) {
        context.commit('updateMainActive', data)
      } else if (data.type === 2) {
        data.index = context.state.menuJson.button[data.parentIndex].sub_button.length - 1
        context.commit('updateSubActive', data)
      } else if (data.type === 3) {
        console.log('click')
        context.commit('updateSubActive', data)
      } else {
        context.commit('clearMenu')
      }
    },
    AddMainMenu (context, data) {
      context.commit('updateAddMain', data)
    },
    SetMainMenu (context, data) {
      context.commit('updateSetMain', data)
    },
    AddSubMenu (context, data) {
      context.commit('updateAddSub', data)
    },
    SetSubMenu (context, data) {
      context.commit('updateSetSub', data)
    },
    mainActive (context, data) {
      context.commit('updateMainActive', data)
    },
    subActive (context, data) {
      context.commit('updateSubActive', data)
    },
    mainPlusActive (context) {
      context.commit('updateMainPlusActive')
    },
    subPlusActive (context, data) {
      context.commit('updateSubPlusActive', data)
    },
    setWechatMenu (context) {
      return new Promise((resolve, reject) => {
        // if (context.state.menuJson.button.length <= 0) {
        //   Message.warning('您未添加任何菜单,请先添加菜单后再进行发布')
        //   reject()
        //   return false
        // }
        let submitData = {
          menu: {}
        }
        submitData.menu = context.state.menuJson
        delete submitData.menu['mainPlusActive']
        submitData.menu.button.forEach((currentValue) => {
          delete currentValue['active']
          delete currentValue['subPlusActive']
          if ((currentValue.sub_button || []).length > 0) {
            delete currentValue['type']
            delete currentValue['media_id']
            delete currentValue['url']
            delete currentValue['value']
            currentValue.sub_button.forEach((curr) => {
              delete curr['active']
            })
          }
        })
        console.log(submitData)
        let str = JSON.stringify(submitData)
        ajax({
          ...api.wechatMenu.setWechatMenu,
          data: {
            WechatJson: str
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    Changed (context, data) {
      context.commit('updateChanged', data)
    }
  }
}
