import ajax from '../util/ajax'
import api from '../util/api'

export default {
  namespaced: true,
  state: {
    keywordList: [],
    tagList: [],
    RuleName: '',
    AutoType: '',
    MessageContent: '',
    MessageImg: '',
    MessageParagraph: '',
    MessageType: '',
    PairType: '',
    Url: '',
    Subscribe: {}
  },
  mutations: {
    updateKeywordList (state, data) {
      state.keywordList = data.list || []
    },
    updateSubscribe (state, data) {
      state.Subscribe = data.list ? data.list[0] : {}
    },
    updateTagList (state, data) {
      state.tagList = data || []
    },
    updateDetail (state, data) {
      console.log(data)
      state.RuleName = data.RuleName
      state.AutoType = data.AutoType
      state.MessageContent = data.MessageContent
      state.MessageImg = data.MessageImg
      state.MessageParagraph = data.MessageParagraph
      state.MessageType = data.MessageType
      state.PairType = data.PairType
      state.Url = data.Url
      let arr = data.Keywords ? data.Keywords.split(',') : []
      state.tagList = arr
    }
  },
  actions: {
    getKeywordList (context, data) {
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.getKeywordList,
          queryData: {
            ...data
          }
        }).then((res) => {
          context.commit('updateKeywordList', res)
          resolve()
        }).catch(reject)
      })
    },
    getSubscribe (context, data) {
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.getKeywordList,
          queryData: {
            ...data
          }
        }).then((res) => {
          context.commit('updateSubscribe', res)
          resolve()
        }).catch(reject)
      })
    },
    getReplyDetail (context, data) {
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.getReplyDetail,
          urlData: {
            ...data
          }
        }).then((res) => {
          context.commit('updateDetail', res)
          resolve()
        }).catch(reject)
      })
    },
    setReply (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.setReply,
          data: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    addReply (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.addReply,
          data: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    deleteReply (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.deleteReply,
          urlData: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    changeIsUse (context, data) {
      console.log(context)
      return new Promise((resolve, reject) => {
        ajax({
          ...api.reply.changeIsUse,
          urlData: {
            ...data
          }
        }).then(() => {
          resolve()
        }).catch(reject)
      })
    },
    changeTag (context, data) {
      let res
      if (data.type === 'add') {
        context.state.tagList.push(data.data)
        res = context.state.tagList
      } else if (data.type === 'delete') {
        let index = context.state.tagList.indexOf(data.item);
        context.state.tagList.splice(index, 1)
        res = context.state.tagList
      } else {
        res = []
      }
      context.commit('updateTagList', res)
    }
  }
}
